﻿Imports System
Imports System.Runtime.InteropServices
Imports DBMDLL

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim inp(99) As Double
        Dim s1 As New Coil()
        Dim ris As Short
        Dim s As String

        'Some check on input data
        If Me.CALCTYPE.Text = "Condenser" And Convert.ToDouble(Me.TGOUT.Text) < Convert.ToDouble(Me.TGIN.Text) Then
            Me.TGIN.Text = "0"
            Me.TGOUT.Text = "20"
            If Me.LIQUIDTYPE.SelectedItem = "Water" Then
                MsgBox("Water is not a valid freon")
                Exit Sub
            End If
        End If
        s1.SetPricePathDBM("DBM")
        If Me.CALCTYPE.Text = "Direct Expansion" And Convert.ToDouble(Me.TGOUT.Text) > Convert.ToDouble(Me.TGIN.Text) Then
            Me.TGIN.Text = "32"
            Me.HUMGIN.Text = "50"
            Me.TGOUT.Text = "18"
        End If



        For i = 0 To 99
            inp(i) = 0
        Next
        If Me.CoilTypeVal.SelectedItem = "P60" Then inp(0) = 1
        If Me.CoilTypeVal.SelectedItem = "P3012" Then inp(0) = 2
        If Me.CoilTypeVal.SelectedItem = "P30" Then inp(0) = 13
        If Me.CoilTypeVal.SelectedItem = "P40" Then inp(0) = 94

        inp(1) = Convert.ToDouble(Me.TGIN.Text)
        inp(2) = Convert.ToDouble(Me.HUMGIN.Text)
        inp(5) = Convert.ToDouble(Me.AIRVOL.Text)
        inp(16) = Convert.ToDouble(Me.PAL.Text)
        inp(18) = Convert.ToDouble(Me.COILLEN.Text)
        inp(19) = Convert.ToDouble(Me.COILHEIGHT.Text)
        ' specify desired capacity or outside temperature
        inp(21) = Convert.ToDouble(Me.KWREQ.Text)
        If inp(21) = 0 Then inp(22) = Convert.ToDouble(Me.TGOUT.Text)
        ' number of rows
        If Convert.ToDouble(Me.NR.Text) > 0 Then
            inp(14) = Convert.ToDouble(Me.NR.Text)
            inp(21) = 0
            inp(22) = 0
        End If
        


        ' type of coil
        If Me.CALCTYPE.SelectedItem = "Liquid" Then inp(59) = 1
        If Me.CALCTYPE.SelectedItem = "Direct Expansion" Then inp(59) = 2
        If Me.CALCTYPE.SelectedItem = "Condenser" Then inp(59) = 3
        ' price multiplier
        inp(51) = Convert.ToDouble(Me.MOLT.Text)

        If inp(59) = 1 Then
            inp(26) = Convert.ToDouble(Me.TLIN.Text)
            ' Set liquid volume OR liquid outside temperature
            inp(29) = Convert.ToDouble(Me.LIQVOL.Text)
            If inp(29) = 0 Then
                inp(27) = Convert.ToDouble(Me.TLOUT.Text)
            End If
            ' max liquid side pressure drop
            If inp(14) > 0 Then ' set number of circuits?
                ' specify number of row and circuits
                inp(17) = Convert.ToDouble(Me.NC.Text) ' number of circuits
                If inp(17) <= 0 Then
                    MsgBox("Please enter rows and circuits number for coil verification")
                    Exit Sub
                End If
            Else
                inp(32) = Convert.ToDouble(Me.DPMAX.Text)
            End If
            ' set ethilen glycol percentage
            inp(42) = Convert.ToDouble(Me.GLIC.Text)
            If inp(42) > 0 And inp(42) < 100 Then inp(40) = 1 Else Me.GLIC.Text = "0"

        End If



        If inp(59) = 2 Then
            If Me.LIQUIDTYPE.SelectedItem = "Steam" Or Me.LIQUIDTYPE.SelectedItem = "Water" Then
                MsgBox("Steam or Water not allowed for ED coils")
                Exit Sub
            End If
            If Me.LIQUIDTYPE.SelectedItem = "R410a" Then inp(45) = 16
            If Me.LIQUIDTYPE.SelectedItem = "R404a" Then inp(45) = 13
            If Me.LIQUIDTYPE.SelectedItem = "R407c" Then inp(45) = 12
            If Me.LIQUIDTYPE.SelectedItem = "R134a" Then inp(45) = 4
            inp(54) = Convert.ToDouble(Me.CONDTEMP.Text)
            inp(56) = Convert.ToDouble(Me.EVAPTEMP.Text)
            If inp(56) >= inp(54) Then
                MsgBox("Wrong condensing or evaporating temperature")
                Exit Sub
            End If
            inp(57) = Convert.ToDouble(Me.SUBCOOL.Text)
            inp(58) = Convert.ToDouble(Me.SUPERHEAT.Text)

        End If
        If inp(59) = 3 Then
            If Me.LIQUIDTYPE.SelectedItem = "R410a" Then inp(45) = 16
            If Me.LIQUIDTYPE.SelectedItem = "R404a" Then inp(45) = 13
            If Me.LIQUIDTYPE.SelectedItem = "R407c" Then inp(45) = 12
            If Me.LIQUIDTYPE.SelectedItem = "R134a" Then inp(45) = 4
            If Me.LIQUIDTYPE.SelectedItem = "Steam" Then inp(45) = 9
            inp(54) = Convert.ToDouble(Me.CONDTEMP.Text)
            inp(56) = Convert.ToDouble(Me.EVAPTEMP.Text)
            If inp(56) >= inp(54) Then
                MsgBox("Wrong condensing or evaporating temperature")
                Exit Sub
            End If
            inp(57) = Convert.ToDouble(Me.SUBCOOL.Text)
            inp(58) = Convert.ToDouble(Me.SUPERHEAT.Text)
            If Me.LIQUIDTYPE.SelectedItem = "Steam" Then
                inp(65) = 6 '  1: Sloped tube - 3: Vertical tubes - 6:Header on same side
            End If

        End If



        ' Calculation mode
        ' 0: std tolerance - 1 reduced tolerance - 2 certified performance
        If Me.CALCMODE.SelectedItem = "Std Tolerance" Then inp(77) = 0
        If Me.CALCMODE.SelectedItem = "Reduced Tolerance" Then inp(77) = 1
        If Me.CALCMODE.SelectedItem = "Certified" Then inp(77) = 2
        s = My.Computer.FileSystem.CurrentDirectory
        ChDir(s)
        ris = s1.ClCoil(inp)

        If ris <> 0 Then
            MsgBox("Error number " & ris)
            Exit Sub
        End If
        Me.CoilType.Text = s1.CoilDesc
        Me.KWOUT.Text = s1.Capacity.ToString()
        Me.OUTAIR.Text = s1.AirOutTemperature.ToString() & "°C - " & s1.AirOutHumidity.ToString() & "%"
        Me.PRICE.Text = s1.CoilPrice.ToString()
        Me.WEIGHT.Text = s1.CoilWeight.ToString()
        Me.INTVOL.Text = (s1.CoilVolume * 1000).ToString()
        Me.DPAIR.Text = s1.AirPressureDrop.ToString()
        Me.DPLIQ.Text = s1.LiquidPressureDrop.ToString()
        If Me.CALCTYPE.SelectedItem = "Liquid" Then
            Me.LIQOUT.Text = s1.LiquidOutTemperature.ToString() & "°C - " & s1.LiquidVolume.ToString() & " dm3/h"
            Me.OUTL.Text = "Liquid outlet cond."
        Else
            Me.LIQOUT.Text = s1.LiquidWeight.ToString() & " kg/h"
            Me.OUTL.Text = "Freon weight"
        End If
        Me.OUTDIM.Text = s1.OverallLength.ToString() & "x" & s1.OverallHeight.ToString() & "x" & s1.OverallWidth.ToString()
        Me.VELAIR.Text = s1.AirVelocity.ToString()
        Me.VELLIQ.Text = s1.LiquidVelocity.ToString()
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.CoilTypeVal.SelectedItem = "P60"
        Me.PAL.SelectedItem = "2,5"
        Me.CALCMODE.SelectedItem = "Reduced Tolerance"
        Me.TGIN.Text = "32"
        Me.HUMGIN.Text = "50"
        Me.TLIN.Text = "7"
        Me.TLOUT.Text = "12"
        Me.KWREQ.Text = "0"
        Me.DPMAX.Text = "30"
        Me.TGOUT.Text = "18"
        Me.COILLEN.Text = "1500"
        Me.COILHEIGHT.Text = "980"
        Me.AIRVOL.Text = "12500"
        Me.LIQVOL.Text = "0"
        Me.GLIC.Text = "0"
        Me.MOLT.Text = "2,2"
        Me.CALCTYPE.SelectedItem = "Liquid"
        Me.LIQUIDTYPE.SelectedItem = "Water"
        Me.CONDTEMP.Text = "40"
        Me.EVAPTEMP.Text = "0"
        Me.SUPERHEAT.Text = "0"
        Me.SUBCOOL.Text = "0"
        Me.NR.Text = "0"
        Me.NC.Text = "0"
        Dim assembly As System.Reflection.Assembly
        assembly = System.Reflection.Assembly.LoadFrom("DBM\DBMDLL.DLL")
        'Dim s1 As New Coil()
        's1.SetPricePathDBM("DBM")

    End Sub


    Private Sub LIQUIDTYPE_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LIQUIDTYPE.SelectedIndexChanged
        If Me.LIQUIDTYPE.SelectedItem = "Steam" Then
            Me.CONDTEMP.Text = 120 ' sample values
            Me.CALCTYPE.SelectedItem = "Condenser"
        End If
        If Me.LIQUIDTYPE.SelectedItem = "Water" And Me.CALCTYPE.SelectedItem <> "Liquid" Then
            Me.LIQUIDTYPE.Text = "R407c"
        End If
        If Me.CALCTYPE.Text = "Condenser" Then
            Me.CONDTEMP.Text = "30"
            Me.EVAPTEMP.Enabled = False
            Me.SUBCOOL.Text = "5"
            Me.SUPERHEAT.Text = "5"
            If Me.LIQUIDTYPE.SelectedItem = "Steam" Then
                Me.CONDTEMP.Text = 120 ' sample values
            End If
        End If

    End Sub
    Private Sub CALCTYPE_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CALCTYPE.SelectedIndexChanged
        If Me.CALCTYPE.Text = "Liquid" Then
            SetControls(True)
            Me.LIQUIDTYPE.SelectedItem = "Water"
        Else
            SetControls(False)
            If Me.CALCTYPE.Text = "Condenser" Then
                Me.CONDTEMP.Text = "40"
                Me.EVAPTEMP.Enabled = False
                Me.SUBCOOL.Text = "5"
                Me.SUPERHEAT.Text = "5"
                If Me.LIQUIDTYPE.SelectedItem = "Steam" Then
                    Me.CONDTEMP.Text = 120 ' sample values
                End If
            Else
                Me.CONDTEMP.Text = "25"
                Me.EVAPTEMP.Enabled = True
                Me.EVAPTEMP.Text = "-5"
                Me.SUBCOOL.Text = "5"
                Me.SUPERHEAT.Text = "5"
                Me.PAL.Text = "3,0" ' for evap temp <0 minimum fin pitch is 3.0, see DBM DLL Documentation
            End If
        End If
    End Sub

    Private Sub SetControls(ByVal bSet As Boolean)

        Me.LIQUIDTYPE.Enabled = Not bSet
        Me.CONDTEMP.Enabled = Not bSet
        Me.EVAPTEMP.Enabled = Not bSet
        Me.SUBCOOL.Enabled = Not bSet
        Me.SUPERHEAT.Enabled = Not bSet
        Me.TLIN.Enabled = bSet
        Me.TLOUT.Enabled = bSet
        Me.GLIC.Enabled = bSet
        Me.DPMAX.Enabled = bSet
        Me.LIQVOL.Enabled = bSet

    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click

        Dim vInp(79) As Double
        Dim s1 As New Coil()
        Dim ris As Long
        Dim s As String

        vInp(0) = 0
        vInp(3) = 0
        vInp(5) = 1 ' water
        vInp(6) = 30 ' glyc percentage %
        vInp(7) = 1 '/ 1: ethil
        vInp(8) = 40 ' Max dp

        vInp(9) = 10500 ' air vol supply
        vInp(10) = 24   ' inlet temp supply
        vInp(11) = 50.7 ' rel hum supply
        vInp(12) = 1200 ' finned length dimension, supply
        vInp(13) = 840  ' finned height supply
        vInp(14) = 0    ' number of rows
        vInp(15) = 0    'number of circuits
        vInp(16) = 2    ' fin pitch supply
        vInp(17) = 0    'liquid volume l/h 0 = auto
        ' exhaust
        vInp(19) = 9300
        vInp(20) = 47.5
        vInp(21) = 34.4
        vInp(22) = 1500
        vInp(23) = 840
        vInp(24) = 0 ' rows 
        vInp(25) = 0 '  circuit
        vInp(26) = 2 ' fin pitch
        vInp(27) = 0 ' l/h , 0 = auto

        '' supply
        vInp(29) = 94 ' P40 
        vInp(30) = 0 ' fin material
        vInp(31) = 0.0 ' spessore	
        vInp(32) = 0 ' inox tubo
        vInp(33) = 0 '.75 ' inox tubo
        vInp(34) = 1 '
        vInp(35) = 16 'telaio fezn 1.5 mm

        ' exhaust
        vInp(39) = 94 ' P40
        vInp(40) = 0 ' fin material
        vInp(41) = 0 ' 
        vInp(42) = 0 ' Ferro tubo
        vInp(43) = 0 ' spessore tubo
        vInp(44) = 1 ' 
        vInp(45) = 16 'frame material index

        vInp(51) = 2.2 'price Multipier
        vInp(53) = 2   ' certified tolerance

        vInp(60) = 0 '
        vInp(61) = Convert.ToDouble(Me.MinEff.Text) '
        vInp(65) = 0 ' 0: finned length, 1 overall length

        s = My.Computer.FileSystem.CurrentDirectory
        ChDir(s)

        ris = s1.ClRecCoil(vInp)
        If (ris <> 0 And ris <> 41100) Then
            MsgBox("Error number " & ris)
            Exit Sub
        End If
        Dim aRis(79) As Double
        Dim bol As Boolean

        If s1.GetRecResult(0, aRis) Then
            ' get numeric results from array as described into documentation, 
            ' for instance efficiency is position 0, total capacity is in pos 1 etc
            Me.Label38.Text = s1.CoilDesc
            Me.Label48.Text = s1.CoilDescExhaust
        End If
        If s1.GetRecResult(1, aRis) Then
            Me.Label40.Text = s1.CoilDesc
            Me.Label46.Text = s1.CoilDescExhaust
        End If
        If s1.GetRecResult(2, aRis) Then
            Me.Label42.Text = s1.CoilDesc
            Me.Label44.Text = s1.CoilDescExhaust
        End If




    End Sub
End Class


